import sensors
from environment import Environment
import DDPG
import tensorflow as tf
import matplotlib.pyplot as plt
import data
import numpy as np


def main():
	with tf.Session() as sess:
		saver = tf.train.import_meta_graph('tmp/straight obs 0-500/containerAdamModel-100.meta')
		sess.run(tf.global_variables_initializer())
		print('Meta graph imported')
		saver.restore(sess, 'tmp/straight obs 0-500/containerAdamModel-100')

		#for op in tf.get_default_graph().get_operations():
		#	print(str(op.name))

		graph = tf.get_default_graph()
		inputs = graph.get_tensor_by_name("InputData/X:0")
		
		shiftedOut = graph.get_tensor_by_name("Add:0")

		

		env = Environment()
		print('Env created')

		maxEpisodeLength = 300
		simData = []
		goals = [[1500,1500],[1500,500],[1500,2500]]
		episode = 1

		for goal in goals:
			epReward = 0
			totalTime = 0
			maxSteps = int(maxEpisodeLength/0.1)
			episodeOut = []

			s = env.reset(goal)
	
			for step in range(maxSteps):
	
				a = sess.run("Add:0", feed_dict={inputs: np.reshape(s,(1,3))})
				
				s2,r,stepdata,terminal = env.sim(a[0])
				epReward += r 
				episodeOut.append(data.saveStepData(step,stepdata,s2,a[0],r,epReward))
				
				s = s2
				totalTime += 0.1
				
				if terminal:
					break
			filename = 'TestResults/targetTest'+str(episode)+'.csv'
			data.data2file(filename,episodeOut)

			#simData.append(data.saveEpisodeData(goal,epReward,totalTime))
			episode += 1

		#filename = 'TestResults/targetSimData.csv'
		#data.data2file(filename,simData)
		print('Done writing to file')


main()