# Should include all functions for calculating rewards.
# Once all functions are fixed these should possibly be added to env
# since the reward signal is described as part of the environment.
# Might be okay to leave separate but include to env if cleaner.

from scipy.stats import multivariate_normal
from scipy.stats import norm
import math
import numpy as np 

# Calculates all elements of reward function and returns the total reward for a given state
# The state in this function should be the calculated nextState since we only recive reward when arriving
# Currently action is not used in this function, but it might be used for action derrivative penalty to make smooth control
def getReward(self,action):
	# Decompose state and action vectors
	# Might need to make this part dependant on what type of vessel is being used
	position = self.nextState[3:5]
	posPrev = self.state[3:5]
	# sensors contains the sensor measurements from all the sensors
	sensors = self.nextState[-4:]
	# start calculating rewards
	R = 0
	# Goal reward
	R += self.goalReward(position)##?? 
	# Directional penalty
	R += self.dirReward(position,posPrev)
	# Obstacle reward (penalty)
	#for sensor in sensors:
	#	R += self.obstaclePenalty(sensor)##??
	# Add any additional rewards/penalties here before returning R
	return R
# Returns the reward for getting close to the goal
def goalReward(self,position):		
	# Boundary type reward
	if self.rewardType == 'boundary':
		error = math.sqrt((position[0] - self.goal[0])**2 + (position[1] - self.goal[1])**2)
		if error <= 50:
			reward = 0.001
		if error <= 20:
			reward = 0.01
		if error <= 5:
			reward = 1 # maxReward = 1? must be chosen
		else:
			reward = 0
	# Gaussian type reward
	elif self.rewardType == 'gaussian':
		# Using multivariate_normal.pdf
		maxReward = 1
		maxNorm = multivariate_normal.pdf(self.goal,mean=self.goal,cov=cov)
		factor = maxReward/maxNorm
		reward = factor*multivariate_normal.pdf(position,mean=self.goal,cov=cov)
	else:
		print('Invalid rewardType = ',self.rewardType,' when calling goalReward()')
	return reward
# Directional reward for moving closer to target
def dirReward(self,pos,posPrev):
	error = math.sqrt((pos[0] - self.goal[0])**2 + (pos[1] - self.goal[1])**2)
	errorPrev = math.sqrt((posPrev[0] - self.goal[0])**2 + (posPrev[1] - self.goal[1])**2)
	if errorPrev > error:
		reward = 0.01
	else:
		reward = 0
	return reward
# Returns the penalty for getting close to an obstacle
def obstaclePenalty(self,sensor):
	# Calculates boundary type penalty
	if self.rewardType == 'boundary':
		# sensor will be larger than boundaryRange when distance is closer
		boundaryRange = 10
		if sensor >= boundaryRange: # Choose value for boundaryRange
			penalty = -0.5 # Choose value for penaltyAmplitude
		else:
			penalty = 0
	# Calculates gaussian type penalty
	elif self.rewardType == 'gaussian':
		distance = self.sensorRange-sensor
		maxPenalty = 1
		maxNorm = norm.pdf(0)
		factor = maxPenalty/maxNorm
		penalty = factor*norm.pdf(distance*0.1) # Add scale change sharpness
												# Scale input to change borders
		#print('Obstacle reward = ',penalty)
	else:
		print('Invalid rewardType = ',self.rewardType,' when calling obstaclePenalty()')
	return penalty
